{(C)SBH       Naprogramoval:    Stanislav Haviar}
program Safety_matches;
uses crt, graph;
type strana=0..2;
     zapis=record
               Jmeno: string[20];
               Body:  integer;
           end;(*record*)
const obrys=white;
      rozmer=40;
      barva1=1; {Vhodne pro forcykly}
      barva2=2;
      max=10;
var
  kdo:      Boolean;                  {Kdo je na tahu}
  hraci:    Array[1..2] of zapis;
  stul:     Array[1..max+1,1..max*2+1] of Boolean; {Kde jsou zapalky}
  rozmer_c: Integer;                               {Cislo N}
  max_y:    Integer;                               {hranice y}
  x,y:      Integer;                               {pozice kurzoru}
  opak, opak2: Integer;                            {for cyklove nezname}
  a:        Char;                                  {nacitani klavesy}
  s:        String;                                {Pomocna stringova (Outtexty)}
  ErrorCode: Integer;                              {Kontrola Egy}
  GrDriver, GrMode: Integer;

{--Zaradi hrace do vysledkove listiny----------------------------------------}
procedure TopTen(hrac: integer);
var F: file of zapis;
    top_ten: Array[1..10] of zapis;
    hotovo: Boolean;
begin
hotovo:=false;
assign(f, 'TopTen.rec');
reset(F);
for opak:=1 to 10 do
read(f, top_ten[opak]);
if hrac<3 then
   begin
     opak:=0;
    repeat
     opak:=opak+1;
     if hraci[hrac].body>top_ten[opak].body then
        begin
          for opak2:=opak to 9 do
              top_ten[opak2]:=top_ten[opak2+1];
          top_ten[opak]:=hraci[hrac];
          hotovo:=true;
        end;
    until hotovo or (opak=10);
   end;
settextjustify(0,0);
settextstyle(0,0,2);
Moveto(0,0);
Outtext('Top Ten:');
settextstyle(0,0,1);
for opak:=1 to 10 do
    begin
      str(top_ten[opak].body, s);
      Moveto(20, 20*opak);
      Outtext(top_ten[opak].jmeno);
      Moveto(150, 20*opak);
      Outtext(s);
    end;
rewrite(F);
for opak:=1 to 10 do
    write(f, top_ten[opak]);
Close(f);
end;
{--Urci barvu pro aktualniho hrace-------------------------------------------}
function barva: strana;
begin
  if kdo then barva:=barva1
     else barva:=barva2;
end;
{--Urci pravou mezni hranici pro prislusne y---------------------------------}
function max_x: Integer;
begin
 if y mod 2 = 0 then max_x:=rozmer_c+1
    else max_x:=rozmer_c;
end;
{--Vykresli jedno policko----------------------------------------------------}
procedure pole(x,y: Integer; vypln: Word; obrys: Boolean);
begin
  setfillstyle(1, vypln);
  bar((x-1)*rozmer+4,(y-1)*rozmer+4,x*rozmer-4, y*rozmer-4);
  setcolor(white);
  if obrys then
     rectangle((x-1)*rozmer,(y-1)*rozmer,x*rozmer, y*rozmer);
end;

{--Vykresli kurzor, nebo zapalku---------------------------------------------}
procedure kurzor(x,y: integer; zobrazeni: strana);
begin
if zobrazeni = 0 then {Ma smazat kurzor}
   begin
     setcolor(obrys);
     if stul[x,y] then zobrazeni:=2; {Prekresli kurzor zapalkou}
   end;
if zobrazeni = 1 then {Ma vykreslit kurzor}
     setcolor(barva);

if zobrazeni = 2 then {ma vykreslit zapalku}
     setcolor(brown);

if (y mod 2 = 0) then   {svisle zapalky}
   line((x-1)*rozmer, round(y/2-1)*rozmer, (x-1)*rozmer, round(y/2)*rozmer)
   else                 {vodorovne}
      line((x-1)*rozmer, (y div 2)*rozmer, x*rozmer, (y div 2)*rozmer)
end;
{--Urci, zda je zaplnena cela plocha-----------------------------------------}
function konec: Boolean;
var splneno: Boolean;
    y_zal: Integer;
begin
 splneno:=true;
 y_zal:=y;
 for y:=1 to rozmer_c*2+1 do
      for opak2:=1 to max_x do if not stul[opak2,y] then splneno:=false;
 y:=y_zal;
 konec:=splneno;
end;
{--Prevede cislo na string tak, aby zabralo tri znaky------------------------}
function tri_znaky(cislo: Integer): string;
begin
str(cislo, s);
if cislo<10 then tri_znaky:='  '+s;
if cislo<100 then tri_znaky:=' '+s;
end;
{--Vypise body---------------------------------------------------------------}
procedure vypis_body;
begin
setfillstyle(1,0);
bar(getmaxx-110, 10, getmaxx, 40);  {Premaze}
settextjustify(2,0);
   for opak:=1 to 2 do
       begin
         s:=hraci[opak].jmeno+': '+tri_znaky(hraci[opak].body);
         setcolor(opak);
         OuttextXY(getmaxx-10, 10+10*opak, s);
       end;
end;
{--Zjisti, zda nebylo zaplneno policko---------------------------------------}
function plny(x,y: Integer): Boolean;
var splneno: Boolean;
begin
splneno:=false;
if y mod 2 = 0 then  {--svisle prilozena--}
   begin
     if x>1 then               {Vlevo od zapalky}
        if stul[x-1,y]   and
           stul[x-1,y+1] and
           stul[x-1,y-1] then
              begin
                pole(x-1,y div 2,barva, false); {vykresli policko}
                splneno:=true;
                hraci[barva].body:=hraci[barva].body+1;
              end;
     if x<max+1 then           {Vpravo od zapalky}
        if stul[x+1,y]   and
           stul[x,y-1]   and
           stul[x,y+1]   then
              begin
                pole(x,y div 2,barva, false);
                splneno:=true;
                hraci[barva].body:=hraci[barva].body+1;
              end;
   end
   else                       {--vodorovne prilozena--}
     begin
       if y>2 then            {nad zapalkou}
          if stul[x,y-2] and
             stul[x,y-1] and
             stul[x+1,y-1] then
                begin
                  pole(x,y div 2,barva, false);
                  splneno:=true;
                  hraci[barva].body:=hraci[barva].body+1;
                end;
       if y<max_y-1 then      {pod zapalkou}
          if stul[x,y+2] and
             stul[x,y+1] and
             stul[x+1,y+1] then
                begin
                  pole(x,(y div 2)+1,barva, false);
                  splneno:=true;
                  hraci[barva].body:=hraci[barva].body+1;
                end;
     end;
if splneno then
   begin
     sound(200); delay(100);
     sound(500); delay(200);
     nosound;
     vypis_body;
   end;
plny:=splneno;
end;
{--Polozi zapalku------------------------------------------------------------}
procedure poloz;
begin
if not stul[x,y] then  {Skontroluje, zda uz tam zapalka neni}
   begin
     sound(800);
     stul[x,y]:=true;
     kurzor(x,y,2);
     if (not plny(x,y)) then kdo:=not kdo;
   end
   else sound(2000);
 delay(200);
 nosound;
end;
{---------------------------Zacatek programu---------------------------------}
begin
  writeln('Ve hre se muzete pohybovyt sipkami nebo PgDown, PgUp, Home, End.');
  writeln('Sirku polozite Entrem, nebo mezernikem.');
  a:=readkey;
  ClrScr;
 repeat
  writeln('Zadejte velikost pole (2 - ',max,'): ');
  readln(rozmer_c);
 until (rozmer_c>=2) and (rozmer_c<=max);

 for opak:=1 to 2 do {Nacte jmena hracu}
      begin
        writeln('Jmeno hrace c.',opak,': ');
        readln(hraci[opak].jmeno);
      end;

  max_y:=rozmer_c*2+1; {Maximalni y}

  for opak:=1 to 2 do hraci[opak].body:=0; {Vynuluje body}

  for y:=1 to max*2+1 do
      for x:=1 to max+1 do stul[x,y]:=false; {Vynuluje pole (sebere sirky)}
{Najde Egu}
  GrDriver := Detect;
  InitGraph(GrDriver, GrMode, ' ');
  ErrorCode := GraphResult;   { Kontrola chyb }
  if ErrorCode <> grOk then
  begin
    Writeln('Chyba grafiky:');
    Writeln(GraphErrorMsg(ErrorCode));
    Writeln('Program peruen...');
    Halt(1);
  end;
  ClearDevice;

  setlinestyle(0,0, thickwidth); {Nastavi tlustou caru pro vsechny vykreslovani}

  for opak:=1 to rozmer_c do
      for opak2:=1 to rozmer_c do
          pole(opak, opak2, black, true); {Vykresli pole}

  x:=1; y:=1;     {Nastavi kurzor vlevo nahoru}
  kurzor(x,y,1);  {Vykresli ho}
  vypis_body;     {Vypise zatim nulove body}
  kdo:=true;      {Zacina prvni}
  repeat
   a:=readkey;
   kurzor(x,y,0); {Smaze kurzor}
   case ord(a) of
{Naho}72: if y>1 then
             begin
               if x=max_x then
                  begin
                    y:=y-1;
                    x:=max_x;
                  end
                  else y:=y-1;
             end;
{Dolu}80: if y<max_y then
             begin
               if x=max_x then
                  begin
                    y:=y+1;
                    x:=max_x;
                  end
                  else y:=y+1;
             end;
{Vlev}75: if x>1 then x:=x-1;
{Vpra}77: if x<max_x then x:=x+1;
{PgUp}73: y:=1;
{PgDw}81: y:=max_y;
{Home}71: x:=1;
{End }79: x:=max_x;
{Ent
 Mez }13, 32: poloz;  {Polozi sirku}
   end;(*Case*)
   kurzor(x,y,1); {Vykresli kurzor}
  until (a=#27) or konec;  {Ukonci se Escape}
  if konec then
     begin
       ClearDevice;
       settextstyle(DefaultFont, HorizDir, 4);
       if hraci[1].body>hraci[2].body then opak:=1
          else if hraci[2].body>hraci[1].body then opak:=2
               else opak:=3;
       settextjustify(centertext, centertext);
       if opak<3 then
          begin
             s:='Zvitezil '+hraci[opak].jmeno;
             OuttextXY(getmaxx div 2, getmaxy div 2, s);
          end
          else
             OuttextXY(getmaxx div 2, getmaxy div 2, 'Remiza');
       delay(500);
       ClearDevice;
       TopTen(opak);
       a:=readkey;
     end;
  CloseGraph;
end.

